//--------------------------------
// bucket manager for making linked
// lists
//---------------------------------

#ifndef BUCKET__H
#define BUCKET__H

typedef struct _BUCKET {
	struct _BUCKET *pNext;	//points to first bucket
	struct _BUCKET *pPrev;	//points to previous bucket
}BUCKET;

typedef struct {
	BUCKET *pHead;
	BUCKET *pTail;
}LIST;

void *newBucket(int size);
void freeBucket(void *pB);
void delBucket(LIST *pList,void *targ);
void insertBucket(void *pO,void *pN);
void *cloneBucket(void *first,void *last);
void *nextBucket(void *pO);
void *prevBucket(void *pO);
void AddObject(LIST *pL,void *pNew);
void *GetHead(LIST *pList);
void *GetTail(LIST *pList);

#endif